## android-platform-tools 34.0.5

=== mdnsresponder/Makefile ===
#
# Top level makefile for Build & Integration.
# 
# This file is used to facilitate checking the mDNSResponder project
# directly out of CVS and submitting to B&I at Apple.
#
# The various platform directories contain makefiles or projects
# specific to that platform.
#
#    B&I builds must respect the following target:
#         install:
#         installsrc:
#         installhdrs:
#         clean:
#

include /Developer/Makefiles/pb_makefiles/platform.make

MVERS = "mDNSResponder-320.10.80"

DDNSWRITECONFIG = "$(DSTROOT)/Library/Application Support/Bonjour/ddnswriteconfig"

installSome:
	cd "$(SRCROOT)/mDNSMacOSX"; xcodebuild install     OBJROOT=$(OBJROOT) SYMROOT=$(SYMROOT) DSTROOT=$(DSTROOT) MVERS=$(MVERS) SDKROOT=$(SDKROOT) -target Build\ Some

SystemLibraries:
	cd "$(SRCROOT)/mDNSMacOSX"; xcodebuild install     OBJROOT=$(OBJROOT) SYMROOT=$(SYMROOT) DSTROOT=$(DSTROOT) MVERS=$(MVERS) SDKROOT=$(SDKROOT) -target SystemLibraries

install:
	cd "$(SRCROOT)/mDNSMacOSX"; xcodebuild install     OBJROOT=$(OBJROOT) SYMROOT=$(SYMROOT) DSTROOT=$(DSTROOT) MVERS=$(MVERS) SDKROOT=$(SDKROOT)
	# Make sure ddnswriteconfig is owned by root:wheel, then make it setuid root executable
	if test -e $(DDNSWRITECONFIG) ; then chown 0:80 $(DDNSWRITECONFIG) ; chmod 4555 $(DDNSWRITECONFIG) ; fi

installsrc:
	ditto . "$(SRCROOT)"

installhdrs::
	cd "$(SRCROOT)/mDNSMacOSX"; xcodebuild installhdrs OBJROOT=$(OBJROOT) SYMROOT=$(SYMROOT) DSTROOT=$(DSTROOT) MVERS=$(MVERS) SDKROOT=$(SDKROOT)  -target SystemLibraries

clean::
	echo clean

=== gki/kmi_abi_chk/Makefile ===
# Copyright (C) 2021 The Android Open Source Project
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

kmi_sym-objs := kmi_sym_main.o kmi_sym_list.o
obj-m += kmi_sym.o

GKI_VER ?= 5.10
GKI_DIR ?= ${ANDROID_BUILD_TOP}/kernel
KSRC=${GKI_DIR}/out/android12-${GKI_VER}/common

GKI_BID ?= 7618735
CFLAGS_kmi_sym_main.o = -DGKI_BID=${GKI_BID}
AFLAGS_kmi_sym_list.o = -DGKI_BID=${GKI_BID}

all:
	make -C $(KSRC) M=$(PWD) modules
	cp kmi_sym.ko prebuilts/kmi_sym-a12-${GKI_VER}-${GKI_BID}.ko

clean:
	make -C $(KSRC) M=$(PWD) clean

=== mdnsresponder/Clients/Makefile ===
# -*- tab-width: 4 -*-
#
# Copyright (c) 2002-2004 Apple Computer, Inc. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Notes:
# $@ means "The file name of the target of the rule"
# $< means "The name of the first prerequisite"
# $+ means "The names of all the prerequisites, with spaces between them, exactly as given"
# For more magic automatic variables, see
# <http://www.gnu.org/software/make/manual/html_chapter/make_10.html#SEC111>

#############################################################################

# On OS X the dns_sd library functions are included in libSystem, which is implicitly linked with every executable
# If /usr/lib/libSystem.dylib exists, then we're on OS X, so we don't need also to link the "dns_sd" shared library
ifneq "$(wildcard /usr/lib/libSystem.dylib)" ""
TARGETS = build/dns-sd build/dns-sd64
LIBS =
else
TARGETS = build/dns-sd
LIBS = -L../mDNSPosix/build/prod/ -ldns_sd
endif

all: $(TARGETS)

clean:
	rm -rf build

build:
	mkdir build

build/dns-sd: build dns-sd.c ClientCommon.c
	cc $(filter %.c %.o, $+) $(LIBS) -I../mDNSShared -Wall -o $@

build/dns-sd64: build dns-sd.c ClientCommon.c
	cc $(filter %.c %.o, $+) $(LIBS) -I../mDNSShared -Wall -o $@ -m64

# Note, we can make a 'fat' version of dns-sd using 'lipo', as shown below, but we
# don't, because we don't want or need a 'fat' version of dns-sd, because it will
# never need to access more than 4GB of data. We build the 64-bit version purely so
# we have a test tool for making sure that the APIs work properly from 64-bit clients.
# lipo -create dns-sd dns-sd64 -output dns-sd-fat

=== mdnsresponder/mDNSPosix/Makefile ===
# -*- tab-width: 4 -*-
#
# Copyright (c) 2002-2004, Apple Computer, Inc. All rights reserved.
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions are met:
#
# 1.  Redistributions of source code must retain the above copyright notice, 
#     this list of conditions and the following disclaimer. 
# 2.  Redistributions in binary form must reproduce the above copyright notice, 
#     this list of conditions and the following disclaimer in the documentation 
#     and/or other materials provided with the distribution. 
# 3.  Neither the name of Apple Computer, Inc. ("Apple") nor the names of its 
#     contributors may be used to endorse or promote products derived from this 
#     software without specific prior written permission. 
#
# THIS SOFTWARE IS PROVIDED BY APPLE AND ITS CONTRIBUTORS "AS IS" AND ANY 
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
# DISCLAIMED. IN NO EVENT SHALL APPLE OR ITS CONTRIBUTORS BE LIABLE FOR ANY 
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND 
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# IMPORTANT NOTE: This is a Makefile for *GNU make*
# On some systems, a different program may be the default "make" command.
# If "make os=xxx" gives lots of errors like "Missing dependency operator",
# then try typing "gmake os=xxx" instead.
#
# This Makefile builds an mDNSResponder daemon and a libdns_sd.so shared library 
# for Linux. It also builds several example programs for embedded systems. 
#
# Make with no arguments to build all production targets.
# 'make DEBUG=1' to build debugging targets.
# 'make clean' or 'make clean DEBUG=1' to delete prod/debug objects & targets
# 'sudo make install [DEBUG=1]' to install mdnsd daemon and libdns_sd.
#
# Notes:
# $@ means "The file name of the target of the rule"
# $< means "The name of the first prerequisite"
# $* means "The stem with which an implicit rule matches"
# $+ means "The names of all the prerequisites, with spaces between them, exactly as given"
# For more magic automatic variables, see
# <http://www.gnu.org/software/make/manual/html_node/Automatic-Variables.html>

#############################################################################

LIBVERS = 1

COREDIR = ../mDNSCore
SHAREDDIR ?= ../mDNSShared
JDK = /usr/jdk

CC = @cc
BISON = @bison
FLEX = @flex
LD = ld -shared
CP = cp
RM = rm
LN = ln -s -f
CFLAGS_COMMON = -I$(COREDIR) -I$(SHAREDDIR) -I$(OBJDIR) -fwrapv -W -Wall -DPID_FILE=\"/var/run/mdnsd.pid\" -DMDNS_UDS_SERVERPATH=\"/var/run/mdnsd\"
CFLAGS_PTHREAD =
LINKOPTS =
LINKOPTS_PTHREAD = -lpthread
LDSUFFIX = so
JAVACFLAGS_OS = -fPIC -shared -ldns_sd

# Set up diverging paths for debug vs. prod builds
DEBUG=0
ifeq ($(DEBUG),1)
CFLAGS_DEBUG = -g -DMDNS_DEBUGMSGS=2 
OBJDIR = objects/debug
BUILDDIR = build/debug
STRIP = echo 
else
# We use -Os for two reasons:
# 1. We want to make small binaries, suitable for putting into hardware devices
# 2. Some of the code analysis warnings only work when some form of optimization is enabled
CFLAGS_DEBUG = -Os -DMDNS_DEBUGMSGS=0 
OBJDIR ?= objects/prod
BUILDDIR ?= build/prod
STRIP = strip -S 
endif

# Configure per-OS peculiarities
ifeq ($(os),solaris)
CFLAGS_DEBUG = -O0 -DMDNS_DEBUGMSGS=0
CFLAGS_OS = -DNOT_HAVE_DAEMON -DNOT_HAVE_SA_LEN -DNOT_HAVE_SOCKLEN_T -DNOT_HAVE_IF_NAMETOINDEX \
	 -DLOG_PERROR=0 -D_XPG4_2 -D__EXTENSIONS__ -DHAVE_BROKEN_RECVIF_NAME -DTARGET_OS_SOLARIS
CC = gcc
LD = gcc -shared
LINKOPTS = -lsocket -lnsl -lresolv
JAVACFLAGS_OS += -I$(JDK)/include/solaris
ifneq ($(DEBUG),1)
STRIP = strip
endif
else

# any target that contains the string "linux"
ifeq ($(findstring linux,$(os)),linux)
CFLAGS_OS = -D_GNU_SOURCE -DHAVE_IPV6 -DNOT_HAVE_SA_LEN -DUSES_NETLINK -DHAVE_LINUX -DTARGET_OS_LINUX -fno-strict-aliasing
LD = gcc -shared
FLEXFLAGS_OS = -l
JAVACFLAGS_OS += -I$(JDK)/include/linux

# uClibc does not support Name Service Switch
ifneq ($(os),linux-uclibc)
OPTIONALTARG = nss_mdns
OPTINSTALL   = InstalledNSS
endif
else

ifeq ($(os),netbsd)
CFLAGS_OS =
LDCONFIG = ldconfig
else

ifeq ($(os),freebsd)
# If not already defined, set LOCALBASE to /usr/local
LOCALBASE?=/usr/local
INSTBASE=$(LOCALBASE)
CFLAGS_OS = -DHAVE_IPV6
# FreeBSD 4 requires threaded code to be compiled and linked using the "-pthread" option,
# and requires that the "-lpthread" link option NOT be used
# This appies only to FreeBSD -- "man cc" on FreeBSD says:
#   FreeBSD SPECIFIC OPTIONS
#     -pthread
#       Link a user-threaded process against libc_r instead of libc.
CFLAGS_PTHREAD   = -pthread -D_THREAD_SAFE
LINKOPTS_PTHREAD = -pthread
JAVACFLAGS_OS += -I$(JDK)/include/freebsd
LDCONFIG = ldconfig
else

ifeq ($(os),openbsd)
CFLAGS_OS = -DHAVE_BROKEN_RECVDSTADDR
LDCONFIG = ldconfig
else

ifeq ($(os),x)
# We have to define __MAC_OS_X_VERSION_MIN_REQUIRED=__MAC_OS_X_VERSION_10_4 or on Leopard
# we get build failures: ‘daemon’ is deprecated (declared at /usr/include/stdlib.h:283)
CFLAGS_OS = -DHAVE_IPV6 -no-cpp-precomp -Werror -Wdeclaration-after-statement \
	-D__MAC_OS_X_VERSION_MIN_REQUIRED=__MAC_OS_X_VERSION_10_4 \
	-D__APPLE_USE_RFC_2292 #-Wunreachable-code
CC = gcc
LD = $(CC) -dynamiclib
LINKOPTS = -lSystem
LDSUFFIX = dylib
JDK = /System/Library/Frameworks/JavaVM.framework/Home
JAVACFLAGS_OS = -dynamiclib -I/System/Library/Frameworks/JavaVM.framework/Headers -framework JavaVM 
else

$(error ERROR: Must specify target OS on command-line, e.g. "make os=x [target]".\
Supported operating systems include: x, linux, linux-uclibc, netbsd, freebsd, openbsd, solaris) 
endif
endif
endif
endif
endif
endif

NSSLIBNAME  := libnss_mdns
NSSVERSION  := 0.2
NSSLIBFILE  := $(NSSLIBNAME)-$(NSSVERSION).so
NSSLINKNAME := $(NSSLIBNAME).so.2
NSSINSTPATH := /lib

# If not otherwise defined, we install into /usr/lib and /usr/include
# and our startup script is called mdns (e.g. /etc/init.d/mdns)
INSTBASE?=/usr
STARTUPSCRIPTNAME?=mdns

ifeq ($(HAVE_IPV6),1)
CFLAGS_OS += -DHAVE_IPV6=1
else
ifeq ($(HAVE_IPV6),0)
CFLAGS_OS += -DHAVE_IPV6=0
endif
endif

# If directory /usr/share/man exists, then we install man pages into that, else /usr/man
ifeq ($(wildcard /usr/share/man), /usr/share/man)
MANPATH := /usr/share/man
else
MANPATH := /usr/man
endif

# If directories /etc/init.d/rc*.d exist, then we install into that (Suse)
ifeq ($(wildcard /etc/init.d/rc2.d/), /etc/init.d/rc2.d/)
STARTUPSCRIPTDIR = /etc/init.d
RUNLEVELSCRIPTSDIR = /etc/init.d
else
# else if directory /etc/rc.d/init.d/ exists, then we install into that (old Linux)
ifeq ($(wildcard /etc/rc.d/init.d/), /etc/rc.d/init.d/)
STARTUPSCRIPTDIR = /etc/rc.d/init.d
RUNLEVELSCRIPTSDIR = /etc/rc.d
else
# else if directory /etc/init.d/ exists, then we install into that (new Linux)
ifeq ($(wildcard /etc/init.d/), /etc/init.d/)
STARTUPSCRIPTDIR = /etc/init.d
RUNLEVELSCRIPTSDIR = /etc
else
# else install into /etc/rc.d/ (*BSD)
STARTUPSCRIPTDIR = $(INSTBASE)/etc/rc.d
endif
endif
endif

CFLAGS = $(CFLAGS_COMMON) $(CFLAGS_OS) $(CFLAGS_DEBUG)

#############################################################################

all: setup Daemon libdns_sd Clients SAClient SAResponder SAProxyResponder Identify NetMonitor dnsextd $(OPTIONALTARG)

install: setup InstalledDaemon InstalledStartup InstalledLib InstalledManPages InstalledClients $(OPTINSTALL)

# 'setup' sets up the build directory structure the way we want
setup:
	@if test ! -d $(OBJDIR)   ; then mkdir -p $(OBJDIR)   ; fi
	@if test ! -d $(BUILDDIR) ; then mkdir -p $(BUILDDIR) ; fi

# clean removes targets and objects
clean:
	@if test -d $(OBJDIR)   ; then rm -r $(OBJDIR)   ; fi
	@if test -d $(BUILDDIR) ; then rm -r $(BUILDDIR) ; fi
	@$(MAKE) -C ../Clients clean

#############################################################################

# daemon target builds the daemon
DAEMONOBJS = $(OBJDIR)/PosixDaemon.c.o $(OBJDIR)/mDNSPosix.c.o $(OBJDIR)/mDNSUNP.c.o $(OBJDIR)/mDNS.c.o \
             $(OBJDIR)/DNSDigest.c.o $(OBJDIR)/uDNS.c.o $(OBJDIR)/DNSCommon.c.o $(OBJDIR)/uds_daemon.c.o \
             $(OBJDIR)/mDNSDebug.c.o $(OBJDIR)/dnssd_ipc.c.o $(OBJDIR)/GenLinkedList.c.o $(OBJDIR)/PlatformCommon.c.o 

# dnsextd target build dnsextd
DNSEXTDOBJ = $(OBJDIR)/mDNSPosix.c.o $(OBJDIR)/mDNSUNP.c.o $(OBJDIR)/mDNSDebug.c.o $(OBJDIR)/GenLinkedList.c.o $(OBJDIR)/DNSDigest.c.o \
             $(OBJDIR)/DNSCommon.c.o $(OBJDIR)/PlatformCommon.c.o $(OBJDIR)/dnsextd_parser.y.o $(OBJDIR)/dnsextd_lexer.l.o

Daemon: setup $(BUILDDIR)/mdnsd
	@echo "Responder daemon done"

$(BUILDDIR)/mdnsd: $(DAEMONOBJS)
	$(CC) -o $@ $+ $(LINKOPTS)
	@$(STRIP) $@

# libdns_sd target builds the client library
libdns_sd: setup $(BUILDDIR)/libdns_sd.$(LDSUFFIX)
	@echo "Client library done"

CLIENTLIBOBJS = $(OBJDIR)/dnssd_clientlib.c.so.o $(OBJDIR)/dnssd_clientstub.c.so.o $(OBJDIR)/dnssd_ipc.c.so.o

$(BUILDDIR)/libdns_sd.$(LDSUFFIX): $(CLIENTLIBOBJS)
	@$(LD) $(LINKOPTS) -o $@ $+
	@$(STRIP) $@

Clients: setup libdns_sd ../Clients/build/dns-sd
	@echo "Clients done"

../Clients/build/dns-sd:
	@$(MAKE) -C ../Clients

# nss_mdns target builds the Name Service Switch module
nss_mdns: setup $(BUILDDIR)/$(NSSLIBFILE)
	@echo "Name Service Switch module done"

$(BUILDDIR)/$(NSSLIBFILE): $(CLIENTLIBOBJS) $(OBJDIR)/nss_mdns.c.so.o
	@$(LD) $(LINKOPTS) -o $@ $+
	@$(STRIP) $@

#############################################################################

# The Install targets place built stuff in their proper places
InstalledDaemon: $(INSTBASE)/sbin/mdnsd
	@echo $+ " installed"

InstalledLib: $(INSTBASE)/lib/libdns_sd.$(LDSUFFIX).$(LIBVERS) $(INSTBASE)/include/dns_sd.h
	@echo $+ " installed"

InstalledStartup: $(STARTUPSCRIPTDIR)/$(STARTUPSCRIPTNAME)
	@echo $+ " installed"

InstalledManPages: $(MANPATH)/man8/mdnsd.8
	@echo $+ " installed"

InstalledClients: $(INSTBASE)/bin/dns-sd
	@echo $+ " installed"

InstalledNSS: $(NSSINSTPATH)/$(NSSLINKNAME) /etc/nss_mdns.conf $(MANPATH)/man5/nss_mdns.conf.5 $(MANPATH)/man8/libnss_mdns.8
	@echo $+ " installed"

# Note: If daemon already installed, we make sure it's stopped before overwriting it
$(INSTBASE)/sbin/mdnsd: $(BUILDDIR)/mdnsd
	@if test -x $@; then $(STARTUPSCRIPTDIR)/$(STARTUPSCRIPTNAME) stop; fi
	$(CP) $< $@

$(INSTBASE)/lib/libdns_sd.$(LDSUFFIX).$(LIBVERS): $(BUILDDIR)/libdns_sd.$(LDSUFFIX)
	$(CP) $< $@
	$(LN) $@ $(INSTBASE)/lib/libdns_sd.$(LDSUFFIX)
ifdef LDCONFIG
    # -m means 'merge into existing database', -R means 'rescan directories'
	$(LDCONFIG) -mR
endif

$(INSTBASE)/include/dns_sd.h: $(SHAREDDIR)/dns_sd.h
	$(CP) $< $@

# We make this target dependent on $(INSTBASE)/sbin/mdnsd because we need to ensure
# that the daemon is installed *before* we try to execute the command to start it.
$(STARTUPSCRIPTDIR)/$(STARTUPSCRIPTNAME): mdnsd.sh $(STARTUPSCRIPTDIR) $(INSTBASE)/sbin/mdnsd
	$(CP) $< $@
	chmod ugo+x $@
	$@ start
ifdef RUNLEVELSCRIPTSDIR
ifeq ($(wildcard $(RUNLEVELSCRIPTSDIR)/runlevels/default), $(RUNLEVELSCRIPTSDIR)/runlevels/default)
	$(LN) $@ $(RUNLEVELSCRIPTSDIR)/runlevels/default/mdns
else
	$(LN) $@ $(RUNLEVELSCRIPTSDIR)/rc2.d/S52mdns
	$(LN) $@ $(RUNLEVELSCRIPTSDIR)/rc3.d/S52mdns
	$(LN) $@ $(RUNLEVELSCRIPTSDIR)/rc4.d/S52mdns
	$(LN) $@ $(RUNLEVELSCRIPTSDIR)/rc5.d/S52mdns
	$(LN) $@ $(RUNLEVELSCRIPTSDIR)/rc0.d/K16mdns
	$(LN) $@ $(RUNLEVELSCRIPTSDIR)/rc6.d/K16mdns
endif
endif

$(MANPATH)/man5/%.5: %.5
	cp $< $@
	chmod 444 $@

$(MANPATH)/man8/%.8: %.8
	cp $< $@
	chmod 444 $@

$(MANPATH)/man8/mdnsd.8: $(SHAREDDIR)/mDNSResponder.8
	cp $< $@
	chmod 444 $@

$(INSTBASE)/bin/dns-sd: ../Clients/build/dns-sd
	$(CP) $< $@

=== fmtlib/test/add-subdirectory-test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1...3.18)

project(fmt-test)

add_subdirectory(../.. fmt)

add_executable(library-test "main.cc")
target_link_libraries(library-test fmt::fmt)
target_compile_options(library-test PRIVATE ${PEDANTIC_COMPILE_FLAGS})
target_include_directories(library-test PUBLIC SYSTEM .)

if (TARGET fmt::fmt-header-only)
  add_executable(header-only-test "main.cc")
  target_link_libraries(header-only-test fmt::fmt-header-only)
  target_compile_options(header-only-test PRIVATE ${PEDANTIC_COMPILE_FLAGS})
  target_include_directories(header-only-test PUBLIC SYSTEM .)
endif ()

=== ide/clion/frameworks/base/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(frameworks_base)

# HWUI
add_subdirectory(libs/hwui/libhwui-arm64-android)
add_subdirectory(libs/hwui/hwuimacro-arm64-android)
add_subdirectory(libs/hwui/hwuimicro-arm64-android)
add_subdirectory(libs/hwui/hwui_unit_tests-arm64-android)

# JNI
add_subdirectory(core/jni/libandroid_runtime-arm64-android)

=== ide/clion/frameworks/native/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(native)
add_subdirectory(libs/gui/libgui-arm64-android)
add_subdirectory(libs/gui/tests/libgui_test-arm64-android)
add_subdirectory(libs/ui/libui-arm64-android)
add_subdirectory(libs/renderengine/librenderengine-arm64-android)
add_subdirectory(services/surfaceflinger/surfaceflinger-arm64-android)
add_subdirectory(services/surfaceflinger/CompositionEngine/libcompositionengine_mocks-arm64-android)
add_subdirectory(services/surfaceflinger/CompositionEngine/libcompositionengine_test-arm64-android)
add_subdirectory(services/surfaceflinger/CompositionEngine/libcompositionengine-arm64-android)
add_subdirectory(services/surfaceflinger/FrameTimeline/libframetimeline-arm64-android)
add_subdirectory(services/surfaceflinger/TimeStats/timestatsproto/libtimestats_proto-arm64-android)
add_subdirectory(services/surfaceflinger/TimeStats/libtimestats-arm64-android)
add_subdirectory(services/surfaceflinger/layerproto/liblayers_proto-arm64-android)
add_subdirectory(services/surfaceflinger/tests/IPC_test-arm64-android)
add_subdirectory(services/surfaceflinger/tests/fakehwc/sffakehwc_test-arm64-android)
add_subdirectory(services/surfaceflinger/tests/SurfaceFlinger_test-arm64-android)
add_subdirectory(services/surfaceflinger/tests/vsync/test-vsync-events-arm64-android)
add_subdirectory(services/surfaceflinger/tests/waitforvsync/test-waitforvsync-arm64-android)
add_subdirectory(services/surfaceflinger/tests/unittests/libsurfaceflinger_unittest-arm64-android)
add_subdirectory(services/surfaceflinger/libSurfaceFlingerProp-arm64-android)
add_subdirectory(services/surfaceflinger/sysprop/libSurfaceFlingerProperties-arm64-android)
add_subdirectory(services/surfaceflinger/fuzzer/surfaceflinger_fuzzer-arm64-android)
add_subdirectory(services/surfaceflinger/fuzzer/surfaceflinger_displayhardware_fuzzer-arm64-android)
add_subdirectory(services/surfaceflinger/fuzzer/surfaceflinger_scheduler_fuzzer-arm64-android)

=== ide/clion/test/vts-testcase/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(vts-testcase)

add_subdirectory(kernel/api/tun/vts_kernel_tun_test-arm-android)
add_subdirectory(kernel/api/bpf_native_test/vts_test_binary_bpf_module-arm-android)
add_subdirectory(kernel/api/qtaguid/vts_test_binary_qtaguid_module-arm-android)
add_subdirectory(kernel/toolchain/vts_kernel_toolchain-arm-android)
add_subdirectory(kernel/bow/vts_test_binary_bow_module-arm-android)
add_subdirectory(kernel/loop/vts_kernel_loopconfig_test-arm-android)
add_subdirectory(security/selinux/policy/VtsSecuritySelinuxPolicyHostTest-x86_64-linux_glibc)
add_subdirectory(security/avb/VtsSecurityAvbTest-arm-android)
add_subdirectory(fuzz/iface_fuzzer/vts_proto_fuzzer-arm-android)
add_subdirectory(fuzz/iface_fuzzer/libvts_proto_fuzzer-arm-android)
add_subdirectory(hal/treble/vintf/vts_treble_vintf_test_all-arm-android)
add_subdirectory(hal/treble/vintf/vts_treble_vintf_vendor_test-arm-android)
add_subdirectory(hal/treble/vintf/vts_treble_vintf_framework_test-arm-android)
add_subdirectory(hal/treble/vintf/vts_treble_vintf_test_o_mr1-arm-android)
add_subdirectory(hal/thermal/V1_0/target_stress/thermal_hidl_stress_test-arm-android)

=== debian/changelog ===
android-platform-tools (34.0.5-9) unstable; urgency=medium

  * Upload to unstable.
  * debian/control:
    - Limit android-sdk-platform-tools Suggests to ARCHs exists.

 -- Roger Shimizu <rosh@debian.org>  Sun, 23 Mar 2025 21:12:23 -0700

android-platform-tools (34.0.5-9~exp1) experimental; urgency=medium

  * Try to add alpha sh4 for adb/fastboot.

 -- Roger Shimizu <rosh@debian.org>  Sat, 22 Mar 2025 01:52:31 -0700

android-platform-tools (34.0.5-8) unstable; urgency=medium

  * debian/control:
    - Add missing Replaces to android-platform-system-core-headers
      (Closes: #1100892).

 -- Roger Shimizu <rosh@debian.org>  Fri, 21 Mar 2025 00:46:04 -0700

android-platform-tools (34.0.5-7) unstable; urgency=medium

  * Upload to unstable.

 -- Roger Shimizu <rosh@debian.org>  Thu, 20 Mar 2025 23:10:42 -0700

android-platform-tools (34.0.5-7~exp1) experimental; urgency=medium

  * Add loong64 for adb/fastboot.

 -- Roger Shimizu <rosh@debian.org>  Mon, 17 Mar 2025 22:24:26 -0700

android-platform-tools (34.0.5-6) unstable; urgency=medium

  * Fix the autopkgtest.

 -- Roger Shimizu <rosh@debian.org>  Sat, 28 Dec 2024 00:27:41 -0800

android-platform-tools (34.0.5-5) unstable; urgency=medium

  * Revert "Revert "d/tests/control & d/rules: Add tests for adbd""
    Now there's adbd in testing, so we can have this test.

 -- Roger Shimizu <rosh@debian.org>  Thu, 26 Dec 2024 01:23:20 -0800

android-platform-tools (34.0.5-4) unstable; urgency=medium

  * Upload to unstable.
  * Revert "d/tests/control & d/rules: Add tests for adbd"
    Tentatively for testing migration.

 -- Roger Shimizu <rosh@debian.org>  Sun, 22 Dec 2024 23:05:31 -0800

android-platform-tools (34.0.5-4~exp2) experimental; urgency=medium

  * Simplify adb/adbd makefiles.
    - Remove debian/system/libadbd.mk.
    - Put common part of adb.mk and adbd.mk into libadb.mk.
    - Leave diff part only in adb.mk and adbd.mk.

 -- Roger Shimizu <rosh@debian.org>  Sun, 22 Dec 2024 21:56:34 -0800

android-platform-tools (34.0.5-4~exp1) experimental; urgency=medium

  [ Julien Massot ]
  * debian: build adbd package.
    While this requires a few patches in order to actually build on
    non-Android systems, `adbd` can be a useful tool for embedded
    developement and probably other use cases.
    As it was previously shipped as `android-tools-adbd` (up until upstream
    version 5.1.1), we also need to conflict with and replace this package
    with the new one.
    Package `adbd` built from this commit has been successfully tested on
    amd64 computers (using network transport) and arm64 devices (PinePhone
    Pro, using USB transport).

  [ Roger Shimizu ]
  * debian/tests/control & debian/rules: Add tests for adbd.

 -- Roger Shimizu <rosh@debian.org>  Fri, 04 Oct 2024 01:42:45 -0700

android-platform-tools (34.0.5-3) unstable; urgency=medium

  * debian/control: B-D 7zip (>= 22.01+dfsg-9)
  * debian/rules: Remove -lto from linking option.
  * debian/include: Revert Add chrono header for gcc-13.

 -- Roger Shimizu <rosh@debian.org>  Sun, 29 Sep 2024 21:35:57 -0700

android-platform-tools (34.0.5-2) unstable; urgency=medium

  * Upload to unstable.

 -- Roger Shimizu <rosh@debian.org>  Mon, 23 Sep 2024 00:50:43 -0700

android-platform-tools (34.0.5-2~exp1) experimental; urgency=medium

  * Use 7z.so from 7zip to replace external/lzma.

 -- Roger Shimizu <rosh@debian.org>  Fri, 20 Sep 2024 01:22:40 -0700

android-platform-tools (34.0.5-1) unstable; urgency=medium

  * debian/patches: Add two revert patches to fix autopkgtest errors.

 -- Roger Shimizu <rosh@debian.org>  Thu, 19 Sep 2024 22:23:38 -0700

android-platform-tools (34.0.5-1~exp1) unstable; urgency=medium

  * New upstream release 34.0.5
  * debian/patches:
    - Refresh patches.
    - Add 2 revert patches to support mips.
    - Add 2 revert patches to make build for ADB.
  * debian/system/*.mk: Update.

 -- Roger Shimizu <rosh@debian.org>  Thu, 19 Sep 2024 02:56:59 -0700

android-platform-tools (34.0.4-2) unstable; urgency=medium

  [ Anurag Kumar ]
  * fix(adb bash-completion): remove old/deprecated commands and add new ones
  * fix(adb bash-completion): add device, forward subcommand & options
  * adb completion: add adb reverse command and suboptions
  * adb completion: add mdns command and suboptions
  * adb bash-completion: remove adb backup command: deprecated
  * adb bash-completion: add options in pull command
  * adb bash-comp: refactor adb push
  * adb bash-comp: add adb sync command and suboptions
  * adb bash-comp: add adb shell command suboptions
  * adb bash-comp: refactor adb install/uninstall subcommands
  * adb bash-comp: add remaining commands
  * adb bash-comp: remove mdns commands for now

  [ Arnaud Ferraris ]
  * d/patches: Drop gki dependency from mkbootimg (Closes: #1050300)

  [ Roger Shimizu ]
  * d/control: Fix ftbfs issue on loong64 (Closes: #1069143)

 -- Roger Shimizu <rosh@debian.org>  Wed, 18 Sep 2024 00:37:52 -0700

android-platform-tools (34.0.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add patch to build against GCC-14 (Closes: #1074811)

 -- tony mancill <tmancill@debian.org>  Thu, 15 Aug 2024 21:12:28 -0700

=== debian/control ===
Source: android-platform-tools
Section: devel
Priority: optional
Maintainer: Android Tools Maintainers <android-tools-devel@lists.alioth.debian.org>
Uploaders:
 Roger Shimizu <rosh@debian.org>,
Build-Depends:
 bash-completion,
 debhelper-compat (= 13),
 dh-exec,
Build-Depends-Arch:
 7zip (>= 22.01+dfsg-9) [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4],
 android-libboringssl-dev (>= 12) [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4],
 clang [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el s390x ppc64 sparc64 riscv64],
 libbrotli-dev [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4],
 libcap-dev [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4],
 libgtest-dev,
 liblz4-dev [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4],
 libpng-dev,
 libprotobuf-dev (>= 3.12) [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4],
 libsquashfuse-dev [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4],
 libsystemd-dev [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4],
 libusb-1.0-0-dev [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4],
 libzstd-dev [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4],
 lld [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el],
 pandoc [amd64 i386 armel armhf arm64 ia64 loong64 mipsel mips64el ppc64el s390x ppc64 riscv64],
 protobuf-compiler (>= 3.12) [amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4],
 python3 [amd64 i386 arm64],
 ronn [alpha arc hppa hurd-amd64 hurd-i386 kfreebsd-amd64 kfreebsd-i386 m68k powerpc sh4 sparc64 x32],
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/android-tools-team/android-platform-tools.git
Vcs-Browser: https://salsa.debian.org/android-tools-team/android-platform-tools
Homepage: https://developer.android.com/studio/releases/platform-tools

Package: android-sdk-libsparse-utils
Architecture: any
Multi-Arch: foreign
Section: utils
Depends: ${shlibs:Depends}, ${misc:Depends},
         android-libbase (= ${binary:Version}),
         android-libsparse (= ${binary:Version}),
         python3,
Breaks: android-tools-fsutils,
        append2simg (<< 1:10.0.0+r36-1~),
        img2simg (<< 1:10.0.0+r36-1~),
        simg2img (<< 1:10.0.0+r36-1~)
Replaces: android-tools-fsutils,
          append2simg (<< 1:10.0.0+r36-1~),
          img2simg (<< 1:10.0.0+r36-1~),
          simg2img (<< 1:10.0.0+r36-1~)
Description: Android sparse image creation tool
 Command line tools to create sparse images for usage with Android devices.
 Includes simg2img, img2simg, simg2simg, simg_dump and append2simg tools.

Package: android-liblog
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: android-liblog-dev (<< 1:33)
Description: Android NDK logger interfaces
 liblog represents an interface to the volatile Android Logging system for NDK
 (Native) applications and libraries. Interfaces for either writing or reading
 logs. The log buffers are divided up in Main, System, Radio and Events
 sub-logs.

Package: android-liblog-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         android-liblog (= ${binary:Version}),
Breaks: android-liblog (<< 1:33)
Replaces: android-liblog (<< 1:33)
Description: Android NDK logger interfaces - Development files
 liblog represents an interface to the volatile Android Logging system for NDK
 (Native) applications and libraries. Interfaces for either writing or reading
 logs. The log buffers are divided up in Main, System, Radio and Events
 sub-logs.
 .
 This package contains the development files.

Package: android-libcutils
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
         android-libbase (= ${binary:Version}),
         libbsd0,
Breaks: android-libcutils-dev (<< 1:33)
Description: Android utils library for C
 This library provides common functionalities for android related tools.
 .
 This library is only used by Android SDK currently.

Package: android-libcutils-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         android-libcutils (= ${binary:Version}),
         android-libbase-dev (= ${binary:Version}),
         android-platform-system-core-headers (= 1:${source:Version}),
         libbsd-dev,
Breaks: android-libcutils (<< 1:33)
Replaces: android-libcutils (<< 1:33)
Description: Android utils library for C - Development files
 This library provides common functionalities for android related tools.
 .
 This library is only used by Android SDK currently.
 .
 This package contains the development files.

Package: adb
Section: utils
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends},
         android-libcutils (= ${binary:Version}),
Recommends: android-sdk-platform-tools-common (>= 28.0.2~)
Provides: android-tools-adb
Description: Android Debug Bridge
 A versatile command line tool that lets you communicate with an emulator
 instance or connected Android-powered device.
 .
 This package recommends "android-sdk-platform-tools-common" which contains
 the udev rules for Android devices. Without this package, adb and fastboot need
 to be running with root permission.

Package: adbd
Section: utils
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends},
         android-libcutils (= 1:${binary:Version}),
Breaks: android-tools-adbd (<< 6.0~)
Replaces: android-tools-adbd (<< 6.0~)
Provides: android-tools-adbd
Description: Android Debug Bridge daemon
 Android Debug Bridge (adb) is a versatile tool that lets you manage the state
 of an emulator instance or Android-powered device. It is a client-server
 program that includes three components:
 .
 A client, which runs on your development machine. You can invoke a
 client from a shell by issuing an adb command. Other Android tools such
 as the ADT plugin and DDMS also create adb clients.
 .
 A server, which runs as a background process on your development
 machine. The server manages communication between the client and the
 adb daemon running on an emulator or device.
 .
 A daemon, which runs as a background process on each emulator or device
 instance.
 .
 This package provides the daemon component.

Package: android-libsparse
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
         android-libbase (= ${binary:Version}),
Breaks: android-libsparse-dev (<< 1:33)
Description: Library for sparse files
 This library provides APIs for creating, manipulating and destroying sparse
 files.
 .
 This library is only used by Android SDK currently.

Package: android-libsparse-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         android-libsparse (= ${binary:Version}),
Breaks: android-libsparse (<< 1:33)
Replaces: android-libsparse (<< 1:33)
Description: Library for sparse files - Development files
 This library provides APIs for creating, manipulating and destroying sparse
 files.
 .
 This library is only used by Android SDK currently.
 .
 This package contains the development files.

Package: android-libutils
Section: libs
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
         android-libbacktrace (= ${binary:Version}),
         android-libcutils (= ${binary:Version}),
Breaks: android-libutils-dev (<< 1:33)
Description: Android Utility Function Library
 This library provides miscellaneous utility functions.
 .
 This library is only used by Android SDK currently.

Package: android-libutils-dev
Section: libdevel
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4
Multi-Arch: same
Depends: ${misc:Depends},
         android-libbacktrace-dev (= ${binary:Version}),
         android-libcutils-dev (= ${binary:Version}),
         android-libutils (= ${binary:Version}),
         android-platform-system-core-headers (= 1:${source:Version}),
Breaks: android-libutils (<< 1:33)
Replaces: android-libutils (<< 1:33)
Description: Android Utility Function Library - Development files
 This library provides miscellaneous utility functions.
 .
 This library is only used by Android SDK currently.
 .
 This package contains the development files.

Package: android-libziparchive
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
         android-libbase (= ${binary:Version}),
Breaks: android-libziparchive-dev (<< 1:33)
Description: Library for ZIP archives
 This library provides APIs for creating and manipulating ZIP archives.
 .
 This library is only used by Android SDK currently.

Package: android-libziparchive-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         android-libziparchive (= ${binary:Version}),
         libgtest-dev,
Breaks: android-libziparchive (<< 1:33)
Replaces: android-libziparchive (<< 1:33)
Description: Library for ZIP archives - Development files
 This library provides APIs for creating and manipulating ZIP archives.
 .
 This library is only used by Android SDK currently.
 .
 This package contains the development files.

Package: android-platform-frameworks-native-headers
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Headers of android-platform-frameworks-native
 This package contains headers in include/android in platform/frameworks/native
 Consists of all the header files ranging from asset_manager.h to window.h.

Package: android-platform-system-core-headers
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: android-libunwind-dev (<< 10.0.0+r36-5)
Replaces: android-libunwind-dev (<< 10.0.0+r36-5)
Description: Shared headers in AOSP repository platform/system/core
 This package contains header files in AOSP repository platform/system/core that
 do not belong to any specific libraries but used by other programs.
 .
 This package currently contains headers in include/private and include/system.

Package: android-libbacktrace
Section: libs
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
         7zip,
         android-libbase (= ${binary:Version}),
Breaks: android-libbacktrace-dev (<< 1:33)
Description: Android backtrace library
 Android backtrace library produce symbolic backtraces for making
 debugging easier.

Package: android-libbacktrace-dev
Section: libdevel
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4
Multi-Arch: same
Depends: ${misc:Depends},
         android-libbacktrace (= ${binary:Version}),
Breaks: android-libbacktrace (<< 1:33)
Replaces: android-libbacktrace (<< 1:33)
Description: Android backtrace library - Development files
 Android backtrace library produce symbolic backtraces for making
 debugging easier.
 .
 This package contains the development files.

Package: android-libbase
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
         android-liblog (= ${binary:Version}),
Breaks: android-libbase-dev (<< 1:33)
Description: Android base library
 This library provides APIs for basic tasks like handling files, Unicode
 strings, logging, memory allocation, integer parsing, etc..
 .
 This library is only used by Android SDK currently.

Package: android-libbase-dev
Section: libdevel
Architecture: any
Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

## Security Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# https://android.googlesource.com/platform/build/soong/+/refs/tags/platform-tools-34.0.5/cc/config/global.go#356
export DEB_CFLAGS_MAINT_APPEND = -fPIC -std=gnu17
export DEB_CXXFLAGS_MAINT_APPEND = -fPIC -std=gnu++2a
export DEB_LDFLAGS_MAINT_APPEND = -fPIC
export DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG -UDEBUG \
  -fmessage-length=0 \
  -fno-exceptions \
  -fno-strict-aliasing \
  -no-canonical-prefixes \

## For get-orig-source
export DEB_SOURCE

## system
export DEB_HOST_MULTIARCH
export DEB_VERSION
# https://android.googlesource.com/platform/development/+/refs/tags/platform-tools-34.0.5/sdk/plat_tools_source.prop_template
export PLATFORM_TOOLS_VERSION = 34.0.5

ifneq (, $(shell which clang))
  export CC = clang
  export CXX = clang++
  export DEB_CFLAGS_MAINT_APPEND += -gdwarf-4
  export DEB_CXXFLAGS_MAINT_APPEND += -gdwarf-4
  export DEB_CPPFLAGS_MAINT_APPEND += \
    -Wno-c99-designator \
    -Wno-gnu-designator \
    -Wno-gnu-folding-constant \

endif
ifneq (, $(shell which lld))
  export DEB_LDFLAGS_MAINT_APPEND += -fuse-ld=lld -Wl,--build-id=sha1
endif

%:
	dh $@ --with bash-completion

# Depends: git-buildpackage repo ssh
get-orig-source:
	debian/scripts/get-orig-source

ifeq ("$(wildcard ../$(DEB_SOURCE)_$(PLATFORM_TOOLS_VERSION).orig.tar.xz)","")
update: get-orig-source
else
update:
endif
	gbp import-orig ../$(DEB_SOURCE)_$(PLATFORM_TOOLS_VERSION).orig.tar.xz \
		--no-interactive --debian-branch=$(shell git symbolic-ref --short HEAD) \
		--postimport="\
		dch -b -v\$$GBP_DEBIAN_VERSION \"New upstream release \$$GBP_UPSTREAM_VERSION\"; \
		git add debian/changelog; \
		git commit -m\"dch: Note new upstream version \$$GBP_UPSTREAM_VERSION\""

## system

s/lib%.a: debian/system/lib%.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

s/lib%.so: debian/system/lib%.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

debian/manpages/system/%.1: debian/manpages/system/%.1.md
ifneq (, $(shell which pandoc))
	pandoc --standalone --from=markdown-smart --to=man --output=$@ $<
else
	ronn -r $<
endif

s/libbacktrace.so: debian/system/libbacktrace.mk s/libcutils.so e/libcpu_features.so
	dh_auto_build --buildsystem=makefile -- --file=$<

s/libbase.so: debian/system/libbase.mk s/liblog.so
	dh_auto_build --buildsystem=makefile -- --file=$<

s/libcutils.so: debian/system/libcutils.mk s/libbase.so
	dh_auto_build --buildsystem=makefile -- --file=$<

s/adb: debian/system/adb.mk s/libziparchive.so s/libadb.a s/libcrypto_utils.a s/libcutils.so debian/manpages/system/adb.1
	dh_auto_build --buildsystem=makefile -- --file=$<

s/adbd: debian/system/adbd.mk s/libadb.a s/libcrypto_utils.a s/libcutils.so
	dh_auto_build --buildsystem=makefile -- --file=$<

s/fastboot: debian/system/fastboot.mk s/adb s/extras/libext4_utils.a s/libsparse.so debian/manpages/system/fastboot.1
	dh_auto_build --buildsystem=makefile -- --file=$<

s/simg2img: debian/system/simg2img.mk s/libbase.so s/libsparse.so
	dh_auto_build --buildsystem=makefile -- --file=$<

s/simg2simg: debian/system/simg2simg.mk s/simg2img
	dh_auto_build --buildsystem=makefile -- --file=$<

s/img2simg: debian/system/img2simg.mk s/simg2img
	dh_auto_build --buildsystem=makefile -- --file=$<

s/append2simg: debian/system/append2simg.mk s/simg2img
	dh_auto_build --buildsystem=makefile -- --file=$<

COMPONENTS = \
  e/libcpu_features.so \
  s/append2simg \
  s/img2simg \
  s/libbacktrace.so \
  s/libbase.so \
  s/libcutils.so \
  s/liblog.so \
  s/libsparse.so \
  s/libutils.so \
  s/libziparchive.so \
  s/simg2img \
  s/simg2simg \

# Whatever depends on BoringSSL must be disabled on MIPS
NON_MIPS_COMPONENTS = s/adb s/adbd s/fastboot
ifneq ($(filter amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4,$(DEB_HOST_ARCH)),)
  COMPONENTS += $(NON_MIPS_COMPONENTS)
endif

# Most components only support ARM, x86 and MIPS, but some can be built
# on all architectures.
COMPONENTS_ANY_ARCH = \
  s/append2simg \
  s/img2simg \
  s/libbase.so \
  s/libcutils.so \
  s/liblog.so \
  s/libsparse.so \
  s/libziparchive.so \
  s/simg2img \
  s/simg2simg \

ifeq ($(filter amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4,$(DEB_HOST_ARCH)),)
  COMPONENTS := $(filter $(COMPONENTS_ANY_ARCH), $(COMPONENTS))
endif

## development

debian/manpages/development/%.1: debian/manpages/development/%.1.md
ifneq (, $(shell which pandoc))
	pandoc --standalone --from=markdown-smart --to=man --output=$@ $<
else
	ronn -r $<
endif

development/etc1tool: debian/development/etc1tool.mk debian/manpages/development/etc1tool.1 f/native/libETC1.a
	dh_auto_build --buildsystem=makefile -- --file=$<

COMPONENTS += development/etc1tool

## frameworks/native

f/native/libETC1.a: debian/frameworks/native/libETC1.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

COMPONENTS += f/native/libETC1.a

## system/extras

s/extras/libext4_utils.a: debian/system/extras/libext4_utils.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

## libnativehelper

libnativehelper/libnativehelper.so: debian/libnativehelper/libnativehelper.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

COMPONENTS += libnativehelper/libnativehelper.so

## dalvik

dalvik/hprof-conv: debian/dalvik/hprof-conv.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

COMPONENTS += dalvik/hprof-conv

## external

e/lib%.so: debian/external/lib%.mk
	dh_auto_build --buildsystem=makefile -- --file=$<

override_dh_auto_build-arch: $(COMPONENTS)

ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
override_dh_auto_test-arch:
	debian/out/development/etc1tool development/tools/templates/ic_launcher_ldpi.png --encode && debian/out/development/etc1tool development/tools/templates/ic_launcher_ldpi.pkm --decode
ifneq ($(filter amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4,$(DEB_HOST_ARCH)),)
	LD_LIBRARY_PATH=debian/out/system debian/out/system/adb version
	LD_LIBRARY_PATH=debian/out/system debian/out/system/adb help
	LD_LIBRARY_PATH=debian/out/system debian/out/system/adb keygen key.txt && ls -l key.txt* && rm key.txt*
	LD_LIBRARY_PATH=debian/out/system debian/out/system/adbd --version
	LD_LIBRARY_PATH=debian/out/system debian/out/system/fastboot --version
	LD_LIBRARY_PATH=debian/out/system debian/out/system/fastboot devices
endif
endif

override_dh_auto_install:
	echo ignore upstream build system install procedure

override_dh_auto_configure-arch:
	rm -rf development/[a-s]* development/v* development/testrunner \
		external/lzma/{Asm,CPP,CS,DOC,Java} external/lzma/C/*.c external/lzma/C/Util
	mkdir -p debian/out/dalvik/tools debian/out/development debian/out/external \
		debian/out/frameworks/native debian/out/system/extras debian/out/libnativehelper
ifneq ($(filter amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4,$(DEB_HOST_ARCH)),)
	for proto in packages/modules/adb/fastdeploy/proto packages/modules/adb/proto; do \
		(cd $$proto && \
			find . -name '*.proto' -printf 'Regenerate %p\n' \
			-exec protoc --cpp_out=. {} \;) \
	done
endif

override_dh_gencontrol:
	dh_gencontrol
	dh_gencontrol -padb -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libbacktrace -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libbacktrace-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libbase -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libbase-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libcutils -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libcutils-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-liblog -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-liblog-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libsparse -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libsparse-dev -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libutils -- -v1:$(DEB_VERSION)
	dh_gencontrol -pandroid-libutils-dev -- -v1:$(DEB_VERSION)

=== debian/tests/control ===
## system

Test-Command: adb version
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4
Depends: adb

Test-Command: adb help
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4
Depends: adb

Test-Command: adb kill-server && adb devices
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4
Depends: adb
Restrictions: allow-stderr

Test-Command: adb keygen key.txt && ls -l key.txt* && rm key.txt*
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4
Depends: adb
Restrictions: allow-stderr

Test-Command: /usr/lib/android-sdk/platform-tools/adbd --version
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4
Depends: adbd

Test-Command: fastboot --version
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4
Depends: fastboot

Test-Command: fastboot devices
Architecture: amd64 i386 armel armhf arm64 loong64 mipsel mips64el ppc64el riscv64 alpha sh4
Depends: fastboot

## development

Test-Command: etc1tool development/tools/templates/ic_launcher_ldpi.png --encode && etc1tool development/tools/templates/ic_launcher_ldpi.pkm --decode
Depends: etc1tool
